/*jslint  browser:  true,
          eqeqeq:   true,
          immed:    false,
          newcap:   true,
          nomen:    false,
          onevar:   true,
          plusplus: false,
          undef:    true,
          white:    false */
/*global */

//first off, we don't want to be stepping on anyone else's format function
if( !String.prototype.format ){
	String.prototype.format = function( obj ){
		var index = 0,
		formatArgs = arguments,
		returnString = this,
		replacement,
		delimiter = "%",
		replacementRegex,
		toString = Object.prototype.toString;
		
		//see if the last argument is regular expression
		if( formatArgs.length > 1 && toString.call( formatArgs[ formatArgs.length - 1 ] ) === '[object RegExp]' ){
			//set the correct regex
			replacementRegex = formatArgs[ formatArgs.length - 1 ];
			//remove the regex from the format args
			Array.prototype.pop.call(formatArgs);
		}
		
		//if there is only 1 argument and it's an array
		if( formatArgs.length === 1 && toString.call(obj) === '[object Array]' ){
			formatArgs = obj;
		}
		
		if( formatArgs.length === 1 && toString.call(obj) === '[object Object]' && !(obj === undefined || obj === null ) ){
			//object replacement
			replacementRegex = replacementRegex || new RegExp(delimiter + "([^" + delimiter + "]*)" + delimiter, "g");
			delimiter = replacementRegex.toString().match(/[^\\\/]/);
			returnString = returnString.replace(replacementRegex, function(str, key){
				if( obj[key] ){
					return obj[key];
				}
				return "";
			});
		}else{
			//single argument replacement
			replacementRegex = replacementRegex || new RegExp(delimiter + "s", "g");
			returnString = returnString.replace(replacementRegex, function(str, offset){
				replacement = formatArgs[index];
				index = index + 1;
				if( replacement !== undefined && replacement !== null ){
					if(toString.call(replacement) === '[object String]' || toString.call(replacement) === '[object Number]' ){
						return replacement;
					}else if(toString.call(replacement) === '[object Function]'){
						return replacement();
					}
				}
				return "";
			});
		}
		
		return returnString;
	};
}